@rem = '-*- Perl -*-';
@rem = '
@echo off
perl -S %0.cmd %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
';

sub sock_close {
    close S;
    die "Socket closed due to SIGINT\n";
}

$SIG{'INT'} = 'sock_close';

$AF_INET = 2;
$SOCK_STREAM = 1;
$IPPROTO_TCP = 6;


($server = $NodeName) =~ tr/A-Z/a-z/;

$sockaddr = 'S n a4 x8';
($name, $aliases, $proto) = getprotobyname('tcp');

($name, $aliases, $adrtype, $length, @serveraddr) = 
    gethostbyname($server);

die "unable to get host address for $server"
	if ($length == 0);

($a, $b, $c, $d) = unpack('C4', $serveraddr[0]);

print "address for $server is $a.$b.$c.$d\n";

if (@ARGV) {

    #
    # This is the code that will do the listen and accept
    #
    
    unless (socket(S, $AF_INET, $SOCK_STREAM, $proto)) {
	($!) = ($!, close(S));
	die "server: socket failed: $!";
    }
    unless (listen(S, 1)) {
	($!) = ($!, close(S));
	die "server: listen failed: $!";
    }
    unless (accept (C, S)) {
	($!) = ($!, close(S));
	die "server: accept failed: $!";
    }
    recv(C, $msg, $len, 0)
}
else {
    &Spawn ("perl -S $0.cmd server", $pid) ||
	die "Can't spawn server process: $!\n";

    sleep(2);  # paranoia

    unless (socket(S, $AF_INET, $SOCK_STREAM, $proto)) {
	($!) = ($!, close(S));
	die "client: socket failed: $!";
    }
    
    $serverproc = pack($sockaddr, $AF_INET, $port, $serveraddr[0]);
    
    unless (connect(S, $serverproc)) {
	($!) = ($!, close(S)); # close S while saving $!
	die "client: connect failed: $!\n";
    }
    
    print "connected to echo service on $serverhost\n";
    print "type control-c to stop program\n";
    
    while(1) {
	print "Input a line: ";
	$line = &gets;
	last if $line eq "quit\n";
	if (send (S, $line, 0) == undef) {
	    ($!) = ($!, close(S)); # close S while saving $!
	    close S;
	    die "send failed: $!\n";
	}
	recv(S, $buffer, 200, 0);
	print "Received: $buffer";
    }
    
    print "Shutting down connection to $serverhost\n";
    shutdown (S, 2);
    close S;
}


sub gets {
    local($s) = "";
    local($c);

    while(read(STDIN, $c, 1) == 1) {
	last if ($c eq "\n");
	$s .= $c;
    }
    "$s\n";
}
	    
__END__
:endofperl
